package edu.stanford.nlp.trees.tregex.tsurgeon;

import java.util.HashMap;
import java.util.Map;

import edu.stanford.nlp.trees.Tree;
import edu.stanford.nlp.trees.tregex.TregexMatcher;

/**
 * @author Roger Levy (rog@nlp.stanford.edu)
 */
class TsurgeonPatternRoot extends TsurgeonPattern {
  CoindexationGenerator coindexer = new CoindexationGenerator();
  Map<String, Tree> newNodeNames;

  public TsurgeonPatternRoot(TsurgeonPattern[] children) {
    super("operations:", children);
    setRoot(this);
  }



  public Tree evaluate(Tree t, TregexMatcher m) {
    newNodeNames = new HashMap<String,Tree>();
    coindexer.setLastIndex(t);
    Tree result = t;
    for(TsurgeonPattern child : children)
      if(child.evaluate(t,m) == null)
        result = null;
    return result;
  }
}
