package ucot.ui;

//TODO comment the general usage of this interface better
//and other related tasks that the interface has to do

/**
 * Interface for a progress bar used in core component to
 * indicate the status of parsing and running the heuristic.
 * 
 * @author UCOT
 */
public interface ProgressBarInterface {
	
	/**
	 * Gets the maximum value for the progress bar.
	 * @return The maximum value for the progress bar.
	 */
	public int getMaximum();
	
	/**
	 * Gets the minimum value for the progress bar.
	 * @return The minimum value for the progress bar.
	 */
	public int getMinimum();
	
	/**
	 * Gets the current percentage completed.
	 * @return Current percentage completed.
	 */
	public double getPercentageComplete();
	
	/**
	 * Gets the current action description.
	 * @return Action description.
	 */
	public String getString();
	
	/**
	 * Gets the current value of the progress bar.
	 * @return Current value.
	 */
	public int getValue();
	
	/**
	 * Sets the maximum value of the progress bar.
	 * @param maximum Maximum value of the progress bar.
	 */
	public void setMaximum(int maximum);
	
	/**
	 * Sets the minimum value of the progress bar.
	 * @param minimum Minimum value of the progress bar.
	 */
	public void setMinimum(int minimum);
	
	/**
	 * Sets the action description string.
	 * @param string Current action description.
	 */
	public void setString(String string);
	
	/**
	 * Sets the current value of the progress bar.
	 * @param value Current value.
	 */
	public void setValue(int value);
	
	/**
	 * Method for setting the progress bar (dialog) visible or hiding it.
	 * @param visible Indicates wether the progress bar is visible or invisible.
	 */
	public void setVisible(boolean visible);
	
}
