package ucot.ui.gui.tree.analyzemodeltree;

import java.util.List;
import java.util.Vector;

import javax.swing.Icon;

import ucot.model.AnalyzeModel;

//TODO comment me
public abstract class TreeItem implements Comparable {
	private String name;
	private AnalyzeTreeModel model;
	private TreeItem parent;
	public TreeItem(String name, AnalyzeTreeModel model, TreeItem parent){
		this.name = name;
		this.model = model;
		this.parent = parent;
	}
	
	public AnalyzeTreeModel getTreeModel(){
		return model;
	}
	
	public AnalyzeModel getAnalyzeModel(){
		if (model != null)
			return model.getAnalyzeModel();
		else return null;
	}
	public String getName(){
		return name;
	}
	
	public String toString(){
		return getName();
	}
	
	public List<TreeItem> getChildren(){
		return new Vector<TreeItem>();
	}
	
	public List<TreeItem> getPath(){
		List<TreeItem> path = new Vector<TreeItem>();
		path.add(0,this);
		if (parent != null){path.addAll(0,parent.getPath());}
		return path;
	}
    
    public TreeItem getParent() {
        return this.parent;
    }
	
    /**
     * Returns Icon for this TreeItem.
     * @return Icon for this TreeItem.
     */
    public abstract Icon getIcon();
    
    public int compareTo(Object o) {
    	if ( o instanceof TreeItem ) {
    		return ((TreeItem)o).getName().compareTo(this.getName());
    	}
    	return -1;
    }
}
